import 'package:flutter_test/flutter_test.dart';
import 'package:rec_api_dart/src/entities/qualifications/qualification.ent.dart';

void main() {
  test('Qualification.fromJson works with basic data', () async {
    final qualification = Qualification.fromJson({
      "id": 9,
      "created": "2022-05-27T08:24:36+00:00",
      "updated": "2022-05-27T08:24:36+00:00",
      "status": "pending",
      "value": true,
      "reviewer": {
        "id": 1240,
        "name": "Juguetes Amarillos SL",
        "offer_count": 1,
        "rec_address": "rPREPeyHm4rg6jMH6oVXsiZc8G",
        "offered_products": "",
        "needed_products": "",
        "limits": [],
        "commissions": [],
        "wallets": [],
        "limit_counts": [],
        "access_key": "3d6d71feeec671076960a12ce5770805da236a80",
        "access_secret": "cCw4pnShGrBiasgjfC2saAVsK5l4CUc1IKlx8wznrW0=",
        "allowed_methods": [],
        "limit_configuration": [],
        "offers": [],
        "activities": [],
        "producing_products": [],
        "consuming_products": [],
        "cif": "G59883280",
        "prefix": "+34",
        "phone": "611020222",
        "zip": "",
        "city": "",
        "country": "",
        "latitude": 0,
        "longitude": 0,
        "fixed_location": false,
        "web": "test.com",
        "address_number": "",
        "neighborhood": "",
        "association": "",
        "observations": "",
        "street": "",
        "street_type": "",
        "comment": "",
        "type": "COMPANY",
        "subtype": "RETAILER",
        "description": "vjvjvjvjgj",
        "schedule":
            "{\"type\":\"timetable\",\"days\":[{\"first_open\":\"08:30\",\"first_close\":\"14:00\",\"second_open\":\"17:01\",\"second_close\":\"11:18\",\"opens\":true},{\"first_open\":\"08:30\",\"first_close\":\"14:00\",\"second_open\":\"17:01\",\"second_close\":\"11:18\",\"opens\":true},{\"first_open\":\"08:30\",\"first_close\":\"14:00\",\"second_open\":\"17:01\",\"second_close\":\"11:18\",\"opens\":true},{\"first_open\":\"08:30\",\"first_close\":\"14:00\",\"second_open\":\"17:01\",\"second_close\":\"11:18\",\"opens\":true},{\"first_open\":\"09:00\",\"first_close\":\"13:01\",\"second_open\":\"18:01\",\"second_close\":\"19:00\",\"opens\":true},{\"first_open\":\"08:30\",\"first_close\":\"14:00\",\"second_open\":\"17:01\",\"second_close\":\"11:18\",\"opens\":false},{\"first_open\":null,\"first_close\":null,\"second_open\":null,\"second_close\":null,\"opens\":false}]}",
        "public_image": "https://api.rec.qbitartifacts.com/static/60bde4e5d9480.jpeg",
        "documents": [],
        "ibans": [],
        "campaigns": [],
        "redeemable_amount": 0,
        "rewarded_amount": 0,
        "rezero_b2b_access": "not_granted",
        "badges": []
      },
      "account": {
        "id": 1249,
        "name": "Aerosoles Rapidos SL",
        "offer_count": 0,
        "rec_address": "rPREPHuo2baJZaW3L1JpzqyVEd",
        "offered_products": "",
        "needed_products": "",
        "limits": [],
        "commissions": [],
        "wallets": [],
        "limit_counts": [],
        "access_key": "bcf3fac881dc33e64c3fce89c4ea4740d157a3e6",
        "access_secret": "XY6DDh4BrHEaBgQxm/a47l++tp/DAQsDKHHO6DXuXrs=",
        "allowed_methods": [],
        "limit_configuration": [],
        "offers": [],
        "activities": [],
        "producing_products": [],
        "consuming_products": [],
        "cif": "H01406461",
        "prefix": "34",
        "phone": "-3611020220",
        "zip": "12132",
        "city": "Barcelona",
        "country": "ESP",
        "latitude": 40.2145644,
        "longitude": -0.1716926,
        "fixed_location": false,
        "web": "https://www.aerosolesrapidos.com",
        "address_number": "1",
        "neighborhood": "",
        "association": "",
        "observations": "",
        "street": "valencia",
        "street_type": "calle",
        "comment": "",
        "type": "timetable",
        "subtype": "RETAILER",
        "description":
            "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc quis justo mauris. Vestibulum sed nisl a elit commodo viverra id iaculis ante. Nunc sed lorem et nisi commodo facilisis. Nullam vel sapien bibendum, blandit augue vitae, pretium magna. Suspendisse in maximus diam, et efficitur nulla. Fusce sed pellentesque eros. In at sodales ligula. Aenean mollis ligula nec tempus dignissim. Mauris dictum vitae nisl id maximus. ",
        "schedule": "Array",
        "public_image": "https://api.rec.qbitartifacts.com/static/609915c5e450b.jpeg",
        "documents": [],
        "ibans": [],
        "campaigns": [],
        "redeemable_amount": 0,
        "rewarded_amount": 0,
        "rezero_b2b_access": "not_granted",
        "badges": []
      },
      "badge": {
        "id": 7,
        "created": "2022-05-26T13:20:04+00:00",
        "updated": "2022-05-26T13:20:04+00:00",
        "name": "Local",
        "name_es": "Local",
        "name_ca": "Local",
        "description": "",
        "description_es": "",
        "description_ca": "El comerç ven productes de proximitat",
        "image_url": "https://rec.barcelona/wp-content/uploads/2022/05/Vecinos.svg"
      }
    });

    expect(qualification.value, true);
    expect(qualification.status, Qualification.STATUS_PENDING);
    expect(qualification.badge.name, 'Local');
  });
}
